# -*- coding:utf-8 -*-
#! /usr/bin/env python
from glob import glob

try:
    import gtk
except ImportError:
    from gi.repository import Gtk as gtk

import gobject
import os
import os.path
import sys

import smbus
import time
import datetime

import os
try:
    from Tkinter import *
    import Tkinter 
    print("pytho2")
except ImportError:
    from tkinter import *
    import tkinter 
    Tkinter = tkinter
    print("pytho3")
import time
import threading
from waveshare_lib import MAX17043
from waveshare_lib import Warning_window
from waveshare_lib import txt_operation
from waveshare_lib import SW61xx
from multiprocessing import Process
import multiprocessing


global Countdown_value
Countdown_value = 60

bus = smbus.SMBus(1)
SW6124 = SW61xx.SW61xx(bus)

global b_level
        
try:
    gauge = MAX17043.MAX17043(bus)
    MAX17043_Error = 0
except IOError as e:
    MAX17043_Error = 1
    
time.sleep(1)

# Find battery nodes
battery_path = "./bat/"
for psu in glob("/sys/class/power_supply/*"):
    with open(os.path.join(psu, 'type')) as f:
        if f.read().startswith('Battery'):
            #print "Found battery at %s" % psu
            battery_path = psu
if not battery_path:
    #print "No battery found!"
    sys.exit(1)

INTERVAL = 2000
BATT_FULL = os.path.join(battery_path, "charge_full")
BATT_NOW = os.path.join(battery_path, "charge_now")
if not os.path.exists(BATT_FULL):
    BATT_FULL = os.path.join(battery_path, "energy_full")
    BATT_NOW = os.path.join(battery_path, "energy_now")
BATT_STATE = os.path.join(os.path.dirname(sys.argv[0]), "bat/status")
IMAGE_LOC = os.path.join(os.path.dirname(sys.argv[0]), "images/battery")
global Warn_V,pow_V ,Charge_detection
Warn_V = 0
pow_V = 0
Charge_detection = 0
global x

x =  multiprocessing.Value('i', 0)
class BatteryTray:
    def __init__(self,Error_t,gauge):
        self.tray = gtk.StatusIcon()
        self.tray.connect('activate', self.refresh)
        self.Error_t =  Error_t
        self.gauge   =  gauge
        self.bat_old = 0
        # Create menu
        menu = gtk.Menu()
        i = gtk.MenuItem("Quit")
        i.show()
        i.connect("activate", self.quit)
        menu.append(i)
        self.tray.connect('popup-menu', self.show_menu, menu)

        # Initalise and start battery display
        self.refresh(None)
        self.tray.set_visible(True)
        gobject.timeout_add(INTERVAL, self.refresh, False)
        try:
            
            txt = txt_operation.txt_operation()
            
            bat = self.gauge.readPercentage()
            config = float(txt.Find_parameters_value("config.txt","bat"))
            
            bat_old = txt.Find_parameters_value("bat_old.txt","bat")
            print "bat %d"%bat
            print "bat_old %d"%bat_old
            if(bat > bat_old):
                if(bat>93 and bat<100.1 and SW6124.Get_battery() > 99):
                    txt.Write_txt("config.txt","bat = "+str(102-bat)+";#")
                if(bat>100 and config > 5):
                    txt.Write_txt("config.txt","bat = "+str(2)+";#")
            if(SW6124.Charge_detection() == 2 and bat>93):
                txt.Write_txt("config.txt","bat = "+str(102-bat)+";#")
                print "3"
            # if(SW6124.Charge_detection() == 1):
                # if(bat>93):
                    # txt.Write_txt("config.txt","bat = "+str(0)+";#")
                # else:
                    # txt.Write_txt("config.txt","bat = "+str(5)+";#")
                # print "4"
            
            if(bat+config > bat_old + 1 and config<5  and bat+config>95):
                txt.Write_txt("config.txt","bat = "+str(6)+";#")
        except IOError as e:
            print ("\r\nCharging detection is disconnected\r\n")
        

    def show_menu(self, widget, event_button, event_time, menu):
        menu.popup(None, None,
            gtk.status_icon_position_menu,
            event_button,
            event_time,
            self.tray
        )
        
    def quit(self, widget):
        gtk.main_quit()
        sys.exit(0)

    
    def Warning_window_output(self):
        self.window = Warning_window.Warning_window()
        self.window.begin_Config("battery_config.txt")
        self.window.Window_creation()
        self.window.set_Low_battery_warning(b_level)
        self.window.Display_window(3)
        self.window = None
    
    
    def refresh(self, widget):
        global b_level,Warn_V,pow_V,Charge_detection
        def slurp(filename):
            f = open(filename)
            return f.read()

        try:
            bat = self.gauge.readPercentage()
            # os.system('ls')
            self.Error_t = 0
        except IOError as e:
            self.Error_t = 1
            bat = 0
        # Charge_detection = 0
        try:
            txt = txt_operation.txt_operation()
            SW6124.Charge_detection()
            SW6124_bat = SW6124.Get_battery()
            bat = bat + float(txt.Find_parameters_value("config.txt","bat"))
            print "bat : %d"%bat
            t = float(txt.Find_parameters_value("config.txt","bat"))
            if(t < 0):
                t= 0
            if(t>10):
                t=10
            if(SW6124.Charge_detection() ==  1):
                if(SW6124_bat > bat):
                    t = t + 0.002
                    txt.Write_txt("config.txt","bat = "+str(t)+";#")
                if(bat >99.7 and bat <100 and SW6124_bat!=100):
                    t = t - 0.01
                if(bat>102):
                    t = t - 0.1
                txt.Write_txt("config.txt","bat = "+str(t)+";#")
            elif(SW6124.Charge_detection() ==  2):
                if(bat > 102.02):
                    t = t - 0.02
                elif(bat < 102):
                    t = t + 0.02
                if(bat<100):
                    t= t + 0.1
                
                txt.Write_txt("config.txt","bat = "+str(t)+";#")
                    
            else :
                if(t > 0):
                    t = t - 0.002
                    txt.Write_txt("config.txt","bat = "+str(t)+";#")
            
            self.bat_old = bat
            txt.Write_txt("bat_old.txt","bat = "+str(bat)+";#")
            
            
            if(SW6124.Charge_detection() !=  0):
                if(Charge_detection != 1):
                    Charge_detection = 1
                    txt = txt_operation.txt_operation()
                    txt.Write_event("Start charging")
                pow_V = 0
                Warn_V  =0
            else:
                if(Charge_detection != 0):
                    Charge_detection = 0
                    txt = txt_operation.txt_operation()
                    txt.Write_event("Stop charging") 
                    if(bat >= 100):
                        txt = txt_operation.txt_operation()
                        txt.Write_event("charging 100%")
        except IOError as e:
            print ("\r\nCharging detection is disconnected\r\n")
            
        b_level=int(bat)
        # print (bat)
        # b_level = 5
        if(b_level>100):
            b_level = 100
        
        if(self.Error_t == 1):
            b_file = IMAGE_LOC+".png"
        else:
            if(Charge_detection == 1):
                b_file = IMAGE_LOC + "." + str(22-int(b_level / 10)) + ".png"
            else :
                b_file = IMAGE_LOC + "." + str(int(b_level / 10)) + ".png"
        self.tray.set_tooltip("%d%%"%( int(b_level)))
        if os.path.exists(b_file):
            self.tray.set_from_file(b_file)
        if(self.Error_t != 1):
            self.tray.set_blinking(b_level <= 5)
            
        
        if(Charge_detection != 1 and self.Error_t == 0):
            if(b_level < 15 and Warn_V == 0 and b_level>5 ):
                Warn_V =1
                Process(target = self.Warning_window_output).start()
                txt = txt_operation.txt_operation()
                txt.Write_event("Low voltage warning")
            if(b_level <= 5 and pow_V==0):
                pow_V = 1
                
                def Countdown():
                    window1 = Warning_window.Warning_window()
                    window1.begin_Config("battery_config.txt")
                    window1.Window_creation()
                    window1.set_Low_battery_warning(b_level)
                    window1.set_Shutdown_countdown(60)
                    def ceshi1():
                        for i in range(0, 60):
                            try:
                                window1.set_Shutdown_countdown(60-i)
                                time.sleep(1)
                                if(SW6124.Charge_detection() !=  0):#充电
                                    window1.close_window()
                                    return 0
                            except BaseException:
                                return 0
                    x1 = threading.Thread(target = ceshi1)
                    x1.setDaemon(True)
                    x1.start()
                    window1.Display_window(60)
        
                def Countdown_pow():
                    for i in range(0, 60+1):
                        print (i)
                        if(SW6124.Charge_detection() !=  0):#充电
                            print ("退出倒计数")
                            break
                        if(i == 60):
                            print ("关机！！！！！！！！！！！！！！！！！！！！！！！！！")
                            txt = txt_operation.txt_operation()
                            txt.Write_event("sudo shutdown now")
                            os.system('sudo shutdown now')
                        time.sleep(1)
                # t1 = threading.Thread(target = Countdown)
                
                t1 = Process(target = Countdown)
                t2 = Process(target = Countdown_pow)
                
                t1.daemon=True
                t2.daemon=True
                
                t1.start()
                t2.start()
                
                window = None
                print ("窗口结束")
        return True

###############################################################################
app = BatteryTray(MAX17043_Error,gauge)
gtk.main()








