class PCF8574 :
    def __init__(self,i2c_smbus,address):
        self.i2c = i2c_smbus
        self.address = address#0x20
        
    def read(self):
        return self.i2c.read_byte(self.address)
    def write(self, data):
        self.i2c.write_byte(self.address, data)
        
        
    def read_pin(self,pin):
        pin = 0x01 << pin
        if(self.i2c.read_byte(self.address)&pin):
            return 1;
        else :
            return 0;
    def write_pin(self, pin, data):
        pin = 0x01 << pin
        data = data & 0x01
        if(data):
            self.i2c.write_byte(self.address, pin | self.i2c.read_byte(self.address))
        else :
            self.i2c.write_byte(self.address, (~pin) & self.i2c.read_byte(self.address))