# coding=utf-8
import re
import datetime
import time


class txt_operation():
    def __init__(self):
        self.file_name = "Log.txt"
        self.data = ""
        
    def Get_Time(self):
         return time.strftime("%Y/%m/%d") +" "+ time.strftime("%H:%M:%S")
    # Write_txt
    def Write_event(self,event):
        try:
            with open(self.file_name, "r+") as f:
                # print (f.read())
                f.write("Event : "+ event +" "+ self.Get_Time() + "\r\n") 
                f.close()
        except BaseException:
            with open(self.file_name, "w+") as f:  
                f.write("Creation time: " + self.Get_Time() + "\r\n"+"Event : "+ event +" "+ self.Get_Time() + "\r\n") 
                f.close()
                
    def Write_txt(self,file_name,data_t):
        with open(file_name, "w+") as f:  
            f.write(data_t) 
            f.close()
        
    def Find_parameters_value(self,file_name,Find_data):
        try:
            with open(file_name, "r") as f:  
                self.data = f.read()  
                f.close()
        except BaseException:
            with open(file_name, "w+") as f:  
                f.write(Find_data+" = 0;#") 
                self.data = Find_data+" = 0;#"
                f.close()
        value = 0
        try:
            value = float(self.Find_parameters(Find_data))
        except BaseException as e:
            value = 0
        return value
        
    def Find_parameters(self,Find_data):
        Find_data = r'\w*' + str(Find_data) + '[\s\S]*?;'
        data_t = ''.join(re.findall(Find_data, self.data, flags=0))
        data_t = ''.join(re.findall( r'\w*=[\s\S]*?;', data_t))
        data_t = re.sub(str(Find_data), '', data_t) 
        data_t = re.sub('[ =;]', '', data_t)
        return data_t
        
        
    def Find_parameters_Suffix(self,Find_data):
        Find_data = r'\w*' + str(Find_data) + '[\s\S]*?;'
        data_t = ''.join(re.findall(Find_data, self.data, flags=0))
        data_t = ''.join(re.findall( r'\w*=[\s\S]*?;', data_t))
        data_t = ''.join(re.findall(r'\.[^.\\/:*?"<>|\r\n]+$', data_t)) 
        data_t = re.sub(str(Find_data), '', data_t)
        data_t = re.sub('[^A-Za-z0-9.]', '', data_t) 
        return data_t
        
        
        